"""
Django settings for TWProject project.

Generated by 'django-admin startproject' using Django 3.2.6.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

import os.path
from pathlib import Path
import sys

PROJECT_ROOT = os.path.normpath(os.path.dirname(__file__))
#change
# dbx='toy'
# DEBUG = True

#global
dbx='stage_techwich'
DEBUG = True

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-6s9ut)w@ci*!i*m68de#aj-nr9%h(w8o074t7u3u(al!k3z_f$'


ALLOWED_HOSTS = ['*']


# Application definition

INSTALLED_APPS = [
    'twapp.apps.TwappConfig',
    'rest_framework',
    'modeltranslation',
    'django.contrib.humanize',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'corsheaders',
    'imagekit',
    'pyfcm'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework.authentication.TokenAuthentication',
    ),
   'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.AllowAny',
    ),
    'DATETIME_FORMAT': '%s',
}

# CORS_ALLOW_CREDENTIALS = True
# ACCESS_CONTROL_ALLOW_HEADERS = True
# CORS_ORIGIN_ALLOW_ALL = True

CORS_ALLOWED_ORIGINS = [
"http://techwich.co","http://madambut.ir","null"
]


CORS_ALLOW_METHODS = [
'DELETE',
'GET',
'OPTIONS',
'PATCH',
'POST',
'PUT',
]


CORS_ALLOW_HEADERS = [
    "accept",
    "accept-encoding",
    "authorization",
    "content-type",
    "dnt",
    "origin",
    "user-agent",
    "x-csrftoken",
    "x-requested-with",
    "sessionKey",
    "languageKey",
]


ROOT_URLCONF = 'TWProject.urls'
TEMPLATE_DIR=os.path.join(BASE_DIR,'templates')
TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [TEMPLATE_DIR],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'TWProject.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.sqlite3',
#         'NAME': BASE_DIR / 'db.sqlite3',
#     }
# }

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': dbx,
        'USER': 'django',
        'PASSWORD': 'TwA!@2022db',
        'HOST': '94.101.189.41',
        'PORT': '3306',
            'OPTIONS': {
             "init_command": "SET foreign_key_checks = 0;",
        },
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Tehran'

USE_I18N = True

USE_L10N = True

USE_TZ = True


gettext = lambda s: s
LANGUAGES = (
    ('en', gettext('English')),
    ('de', gettext('German')),
    ('fa', gettext('Farsi')),
    ('es', gettext('Spanish')),
    ('ar', gettext('Arabic')),
)

# MODELTRANSLATION_LANGUAGES = ('en', 'de', 'fa', 'ar', 'es')


# MODELTRANSLATION_DEFAULT_LANGUAGE = 'en'
# MODELTRANSLATION_PREPOPULATE_LANGUAGE = 'en'


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

#static files setting
STATIC_URL = '/static/'
STATICFILES_DIRS = [os.path.join(BASE_DIR, 'static')]
STATIC_ROOT = STATIC_URL


#media files
MEDIA_DIR = os.path.join(BASE_DIR, 'media')
MEDIA_ROOT = MEDIA_DIR
MEDIA_URL = 'media/'


# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

FCM_SERVER_KEY = 'AAAAx1QkIrU:APA91bHruS5DfU41R8jefhGMUGLm9STHqbOgOetZKBrFS7kDJ0iJkx4AX-TYF93hhrCE8jP66PEMYi6qDrGDQJ9oMeBzTvIho65G4IvDqLUm0wByVf7PtQdt4dVJVfT8An8AHEjD8SQf'

#smtp
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'

EMAIL_HOST = 'mail.privateemail.com'
EMAIL_HOST_USER = 'verification@techwich.net'
EMAIL_HOST_PASSWORD = 'VrF!@2021'
EMAIL_PORT = 587
EMAIL_USE_TLS = True
EMAIL_USE_SSl = True
DEFAULT_FROM_EMAIL = EMAIL_HOST_USER

